package app;

import java.io.*;
import javax.microedition.lcdui.*;
import javax.microedition.midlet.MIDlet;

public class App extends MIDlet 
{

  private Display display;
  private Displayable saveDisplayable;
  private Explorer explorer; 

  public App() 
  {
    display = Display.getDisplay(this);
    explorer = new Explorer(display, this);
  }

  public void startApp() 
  {
    if (saveDisplayable != null) display.setCurrent(saveDisplayable);
    else display.setCurrent(explorer.getDisplayable());
  }
  
  public void pauseApp() 
  {
    saveDisplayable = display.getCurrent();
  }

  public void destroyApp(boolean unconditional) 
  {
    saveDisplayable = null;
    display.setCurrent(null);
  }

  public void quitApp() {
    destroyApp(false);
    notifyDestroyed();
  }
  
}
