package app;

import java.io.*;
import java.util.*;
import javax.microedition.io.*;
import javax.microedition.io.file.*;
import javax.microedition.lcdui.*;
import javax.microedition.lcdui.List;

public class Explorer implements CommandListener 
{

  private static Image imageFolder;
  private static Image imageFile;

  private Display display;
  private App parent;
  private List list;
  private String root = "";
  private Command commandExit = new Command("Exit", Command.BACK, 0);
  private Command commandSelect = new Command("Select", Command.OK, 0);
  
  static 
  {
    try
    {
      imageFolder = Image.createImage("/res/folder.png");
      imageFile = Image.createImage("/res/file.png");
    }
    catch (IOException e)
    {
    }
  }

  public Explorer(Display display, App parent) 
  {
    this.display = display;
    this.parent = parent;
    createList();
  }
  
  public Displayable getDisplayable() 
  {
    return list;
  }
  
  private void createList() 
  {
    list = null;
    if (!root.equals("")) list = new List(root, List.IMPLICIT);
    else list = new List("My phone", List.IMPLICIT);
    list.addCommand(commandExit);
    list.setSelectCommand(commandSelect);    
    list.setCommandListener(this);    
    Enumeration en;  
    if (root.equals("")) 
    {
      try
      {
        en = FileSystemRegistry.listRoots();
      }
      catch (Exception e)
      {
        en = null;
      }
    } else 
    {
      try
      {
        FileConnection conn = (FileConnection)Connector.open("file:///" + root, Connector.READ);
        en = conn.list("*", true);
        conn.close();
        list.append("../", imageFolder);
      }
      catch (Exception e)
      {
        en = null;
      }
    }
    if (en != null) 
    {   
      while(en.hasMoreElements()) 
      {       
        String s = "" + en.nextElement();
        if (s.endsWith("/")) 
        {
          s = s.substring(0, s.length() - 1);
          list.append(s.substring(s.lastIndexOf('/') + 1) + "/", imageFolder);
        } else 
        {
          s = s.substring(s.lastIndexOf('/') + 1);
          list.append(s, imageFile);
        }
      }
    }
  }
  
  public void commandAction(Command c, Displayable d) 
  {
    int indx = list.getSelectedIndex();
    if (c == commandExit) parent.quitApp();
    else if (c == commandSelect) 
    {
      if (indx != -1) 
      {
        String s = list.getString(indx).toUpperCase();
        if (s.equals("../")) 
        {
          s = root.substring(0, root.length() - 1);
          int l = s.lastIndexOf('/') + 1;
          root = s.substring(0, l);
          createList();
          display.setCurrent(list);
        } else if (s.endsWith("/")) 
        {
          root += list.getString(indx);
          createList();
          display.setCurrent(list);
        } else new BTList(display, list, "/" + root + list.getString(indx));
      }      
    } 
  }
  
}
